package PetshopSpider;

/*
  This class is used by HTMLRetriever to extracting new URLs.
  */

import java.util.*;
import java.io.*;

class URLExtractor extends Thread {

  // Constructors

  URLExtractor(BufferedInputStream bin, Resource base) {
    base_url = base;
    writable = false;
    this.bin = bin;
    success = false;
    token = new byte[1500];
  }

  URLExtractor(BufferedInputStream bin, BufferedOutputStream bout, Resource base) {
    this.base_url = base;
    this.writable = true;
    this.bin = bin;
    this.bout = bout;
    success = false;
    token = new byte[1500];
  }

  // downloadFile and returns Resource vector.
  public void run() {

    is_end = false;
    int getref_count = 0, url_count = 0; // for debug.
    

    // Resource vector as result.
    resources = new Vector();

    String url_str;
    Resource rs;

    try {
      for(;;) {
	getREF(); // Find out reference.
	this.yield();
	if(is_end) break;
	getref_count++;
	
	getURL(); // Extract URL string.
	this.yield();
	url_str = new String(token, 0, token_len);
	rs = new Resource(base_url, url_str);
	if(rs.getOK()) {
	  url_count++; // For debug.
	  resources.addElement(rs);
	}
	if(is_end) break;
      }

      // Write out left characters.
      if(writable)
	bout.flush();
    } catch(IOException e) {
      Print.debug("UE: failed to prcess ");
      resources = null;
      return;
    }

    Print.debug("UE: REF count:"+getref_count+"  URL count:"+url_count);
    base_url = null; bin = null; bout = null;
    success = true;
  }

  // Extract URLs from stream.
  private void getURL() throws IOException {
    skipDelimiters();
    token_len = 0;
    if(is_end) return;
    addChar();
    readUpURL();
    if(is_end) return;
  }

  // Get a reference.
  private void getREF() throws IOException {
    for(;;) {
      skipDelimiters();
      if(is_end) return;

      if(checkREF())
	return;
      else
	if(is_end) return;
    }
  }

  private boolean checkREF() throws IOException {
    token_len = 0;
    if(cc=='h' || cc=='H') {
      readUp();
      if(is_end) return false;
      if(token_len!=3) return false;
      if(token[0]!='r' && token[0]!='R') return false;
      if(token[1]!='e' && token[1]!='E') return false;
      if(token[2]!='f' && token[2]!='F') return false;
      return true;
    }
    if(cc=='s' || cc=='S') {
      readUp();
      if(is_end) return false;
      if(token_len!=2) return false;
      if(token[0]!='r' && token[0]!='R') return false;
      if(token[1]!='c' && token[1]!='C') return false;
      return true;
    }
    skipChars();
    return false;
  }

  // Skip delimiters until normal characters appears.
  private void skipDelimiters() throws IOException {
    for(;;) {
      cc = bin.read();
      if(cc<0) {
	is_end = true;
	return;
      }

      // If writable mode.
      if(writable) bout.write(cc);

      if(cc<=0x20) continue;
      if(cc=='<' || cc=='>' || cc=='\"' || cc=='=') continue;
      return;
    }
  }

  // Skip normal characters until delimiters appears.
  private void skipChars() throws IOException {
    for(;;) {
      cc = bin.read();
      if(cc<0) {
	is_end = true;
	return;
      }

      // If writable mode.
      if(writable) bout.write(cc);

      if(cc>0x20 && cc!='<' && cc!='>' && cc!='\"' && cc!='=')
	continue;
      return;
    }
  }

  // Like a skipChars method, but save character into token buffer.
  private void readUp() throws IOException {
    for(;;) {
      cc = bin.read();
      if(cc<0) {
	is_end = true;
	return;
      }

      // If writable mode.
      if(writable)
	bout.write(cc);

      if(cc>0x20 && cc!='<' && cc!='>' && cc!='\"' && cc!='=') {
	addChar();
	continue;
      }
      return;
    }
  }

  // Almost like just privious method, but except '=' for CGI url.
  private void readUpURL() throws IOException {
    for(;;) {
      cc = bin.read();
      if(cc<0) {
	is_end = true;
	return;
      }
      
      // If writable mode.
      if(writable)
	bout.write(cc);
      
      if(cc>0x20 && cc!='<' && cc!='>' && cc!='\"') {
	addChar();
	continue;
      }
      return;
    }
  }

  // Interfaces
  public Enumeration getURLs() {
    return resources.elements();
  }

  public boolean isSuccess() {
    return success;
  }

  // Add a character to token buffer.
  private void addChar() {
    if(token.length>token_len)
      token[token_len++] = (byte)cc;
    else { // Expand token buffer.
      byte[] temp = new byte[token.length*2];
      for(int i=0;i<token.length;i++)
	temp[i] = token[i];
      token = temp; temp = null;
      token[token_len++] = (byte)cc;
    }
  }

  // Variables
  Resource base_url;
  boolean writable;
  BufferedInputStream bin;
  BufferedOutputStream bout;

  // Token buffer
  byte[] token;
  int token_len;

  // Status of stream
  private boolean is_end;
  // Current char;
  private int cc;

  // As result.
  private Vector resources;
  boolean success;
}
